#!/usr/bin/env node

const chalk = require('ide-util').chalk;
const spawn = require('cross-spawn');

const script = process.argv[2];
const args = process.argv.slice(3);

const aliasMap = {
  s: 'server',
  p: 'pack',
  pub: 'publish',
};

switch (script) {
  case '-v':
  case '--version':
    console.log(require('../package.json').version);
    break;
  case 's':
  case 'p':
  case 'server':
  case 'pack':
  case 'publish':
    var result = spawn.sync(
      'node',
      [require.resolve(`../lib/scripts/${aliasMap[script] || script}`)].concat(args),
      { stdio: 'inherit' } // eslint-disable-line
    );
    process.exit(result.status);
    break;
  default:
    console.log(`Unknown script ${chalk.cyan(script)}.`);
    break;
}
