'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); // eslint-disable-line

exports.default = function (req, res, next) {
  var cwd = process.cwd();
  var pageName = void 0;
  var match = req.path.match(PAGE_REG);
  if (match) {
    var _match = _slicedToArray(match, 1);
    // /abc.html


    pageName = _match[0];
  } else {
    // /abc, /abc/
    pageName = (req.path + '/').replace('//', '/') + 'index.html';
  }
  pageName = pageName.slice(1);

  // *.html, *.js, *.jsx, *.aml, *.axml 存在都可以进入
  if ((_fs2.default.existsSync(pageName) || _fs2.default.existsSync(pageName.replace(/\.html$/g, '.js')) || _fs2.default.existsSync(pageName.replace(/\.html$/g, '.jsx')) || _fs2.default.existsSync(pageName.replace(/\.html$/g, '.aml')) || _fs2.default.existsSync(pageName.replace(/\.html$/g, '.axml'))) && pageName.indexOf('.html') > -1 && pageName.match(/(^pages\/\S+\/index.html$)|((?!^.*\/)^\S+.html$)/g)) {
    var query = req.query || {};
    var fdRenderAPI = '' + (0, _utils.getRemote)(cwd, '/api/v1/render') + (query.pack ? '&__showPack=true' : '');
    console.log('start to render ' + pageName + ' from: ', fdRenderAPI);
    _ideUtil.superagent.post(fdRenderAPI).type('json').send({
      fileList: JSON.stringify(loadFiles(cwd)),
      pageName: pageName
    }).timeout({
      deadline: 60000 // 1分钟
    }).end(function (err, ret) {
      if (err || !ret || !ret.body || ret.body.html === undefined) {
        if (err && err.timeout) {
          res.end('<!DOCTYPE html><html><head><meta charset="utf-8"></head><body>请求超时，请检测网络连接是否正常或者是否开启代理。</body></html>');
        } else {
          res.json(err || { errorMsg: 'render error' });
        }
      } else {
        if (typeof ret.body.html === 'string') {
          var content = ret.body.html;
          var injectContent = injectStyle + injectScript;
          if (content.match(/<head>/)) {
            content = content.replace(/<head>/, '<head>' + injectContent);
          } else {
            content = injectContent + content;
          }
          res.end(content);
        } else {
          res.json(ret.body.html);
        }
        // 如果有 schema.json 返回则保存至本地
        saveJsonFilesToLocal(ret.body.jsonFileList, cwd);
      }
    });
    return;
  } else if (_fs2.default.existsSync(pageName) && pageName.indexOf('.html') > -1) {
    // 针对非 *.html 和 pages/*/html 的内容直接返回。
    return;
  }
  next();
};

var _path = require('path');

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _ideUtil = require('ide-util');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

process.env.NODE_TLS_REJECT_UNAUTHORIZED = '0';

var PAGE_REG = /\/\S+\.html/i;

var injectStyle = ['<style type="text/css">', '#J_Fengdie_Tips_Render{position:fixed;top:0;left:0;width:100%;height:auto;background-color:rgba(255,0,0,0.7);margin:0;padding:10px 0 15px 0}', '#J_Fengdie_Tips_Render h3{margin:0;padding:10px;display:block;font-size:16px;color:#fff}', '#J_Fengdie_Tips_Render div{margin:0;padding:15px;background-color:rgba(0,0,0,0.45);display:block;font-size:14px;color:#fff;border-bottom:1px solid #646464;word-break:break-all}', '</style>'].join('\n');

var injectScript = ['<script>', 'window.FENGDIE_TIPS_RENDER_ERROR = [];', 'window.addEventListener("error", function(e) {', 'if (e.target && e.target.tagName === "SCRIPT"){', 'window.FENGDIE_TIPS_RENDER_ERROR.push("脚本: " + e.target.getAttribute("src"));', '}', 'if(e.target && e.target.tagName === "IMG"){', 'window.FENGDIE_TIPS_RENDER_ERROR.push(e.target.getAttribute("src") ? "图片: " + e.target.getAttribute("src") : "图片: 空路径");', '}', 'if (e.target && e.target.tagName === "LINK") {', 'window.FENGDIE_TIPS_RENDER_ERROR.push("样式: " + e.target.getAttribute("href"));', '}', '}, true);', 'window.addEventListener("load", function(e) {', 'if (window.FENGDIE_TIPS_RENDER_ERROR.length) {', 'const container = document.createElement("div");', 'container.id = "J_Fengdie_Tips_Render";', 'const tip = document.createElement("h3"); ', 'tip.textContent = "凤蝶友情提醒，以下资源可能存在引用出错的问题：";', 'container.appendChild(tip);', 'for (let i = window.FENGDIE_TIPS_RENDER_ERROR.length - 1; i >= 0; i--) {', 'const asset = document.createElement("div");', 'asset.textContent = window.FENGDIE_TIPS_RENDER_ERROR[i];', 'container.appendChild(asset);', '}', 'document.body.appendChild(container);', '}', '})', '</script>'].join('\n');

// 遍历目录下的 *.html *.json *.schema 文件, 待上传服务端
function loadFiles(cwd) {
  var files = {};
  _ideUtil.glob.sync('{*.html,*.js,*.jsx,*.aml,*.axml,*.json,*.schema}', {
    root: cwd,
    cwd: cwd,
    matchBase: true,
    ignore: ['node_modules/**', 'dist/**', '.DS_Store', '.idea']
  }).forEach(function (file) {
    var filePath = (0, _path.join)(cwd, file);
    var st = _fs2.default.statSync(filePath);
    if (st.isFile()) {
      files[file] = _fs2.default.readFileSync(filePath).toString();
    }
  });

  var config = (0, _utils.getFengdieConfig)(cwd);
  var packageJson = (0, _utils.getPackageJson)(cwd);
  packageJson.fengdie = config;
  files['package.json'] = JSON.stringify(packageJson);

  return files;
}

function saveJsonFilesToLocal() {
  var fileList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var cwd = arguments[1];

  Object.keys(fileList).forEach(function (fileName) {
    var filePath = (0, _path.join)(cwd, fileName);
    (0, _ideUtil.mkdirp)((0, _path.dirname)(filePath));
    _fs2.default.writeFileSync(filePath, JSON.stringify(fileList[fileName], null, 2));
  });
}

module.exports = exports['default'];