'use strict';

var _server = require('../server');

var _server2 = _interopRequireDefault(_server);

var _utils = require('../utils');

var _build = require('../build');

var _build2 = _interopRequireDefault(_build);

var _pack = require('../pack');

var _pack2 = _interopRequireDefault(_pack);

var _ideUtil = require('ide-util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line

var _require$option$optio = require('yargs').option('cwd', {
  type: 'string',
  describe: 'Project path',
  default: null
}).option('port', {
  type: 'string',
  describe: 'Server Port',
  default: null
}).options('type', {
  type: 'string',
  describe: 'The type of script',
  default: null
}).help('h'),
    argv = _require$option$optio.argv;

if (argv.type === 'server') {
  process.env.NODE_ENV = 'development';
  process.env.DEBUG = true;

  var s = function s() {
    (0, _server2.default)(argv);
  };
  (0, _utils.installDeps)(argv.cwd || process.cwd()).then(s, s);
} else if (argv.type === 'pack') {
  var buildPack = function buildPack() {
    (0, _build2.default)(argv).then(function () {
      (0, _pack2.default)(argv).then(function (_ref) {
        var tarFile = _ref.tarFile,
            spinner = _ref.spinner;

        spinner.succeed('\u6253\u5305\u6210\u529F\uFF0C\u8F93\u51FA\u8DEF\u5F84\uFF1A ' + tarFile);
      }).catch(function (err) {
        console.log(_ideUtil.chalk.red(err));
        process.exit(1);
      });
    }).catch(function (err) {
      console.log(_ideUtil.chalk.red(err));
      process.exit(1);
    });
  };

  (0, _utils.installDeps)(argv.cwd || process.cwd()).then(buildPack, buildPack);
}