'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = server;

var _dev = require('ide-webpack-common/lib/dev');

var _dev2 = _interopRequireDefault(_dev);

var _ideUtil = require('ide-util');

var _utils = require('./utils');

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

var _mock = require('./mock');

var _mock2 = _interopRequireDefault(_mock);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-line
function runWebpack(args, cwd) {
  console.log('Run webpack');
  var webpackConfig = (0, _utils.getWebpackConfig)('dev', cwd);
  var appName = 'myFengdieApp';
  var serverConfig = {
    compress: true,
    clientLogLevel: 'none',
    // 本地不 serve 静态资源
    // contentBase: cwd,
    contentBase: false,
    hot: true,
    publicPath: webpackConfig.output.publicPath,
    quiet: true,
    watchOptions: {
      ignored: /node_modules/,
      aggregateTimeout: 1000,
      poll: 1000
    },
    https: false,
    host: '0.0.0.0',
    useLocalIp: true,
    disableHostCheck: true,
    headers: {
      'Cache-control': 'no-cache'
    },
    before: function before(app) {
      app.get('/', _render2.default);
      app.post('/:url*', _mock2.default);
      app.put('/:url*', _mock2.default);
      app.get('/*', _render2.default);
    }
  };
  (0, _dev2.default)({
    args: args,
    webpackConfig: webpackConfig,
    appName: appName,
    serverConfig: serverConfig,
    afterServer: function afterServer(devServer) {
      process.on('SIGINT', function () {
        devServer.close();
      });
    }
  });
} //eslint-disable-line

function server() {
  var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  try {
    var cwd = args.cwd || process.cwd();
    runWebpack(args, cwd);
  } catch (e) {
    console.error(e);
    (0, _ideUtil.send)({ type: _ideUtil.DONE, errors: e.stack });
  }
}
module.exports = exports['default'];